<template>
  <div
    class="group relative flex h-6 w-8 flex-col items-end justify-between [&_span]:pointer-events-none [&_span]:h-1 [&_span]:rounded-md [&_span]:bg-slate-600 [&_span]:transition-all"
  >
    <input
      v-model="value"
      type="checkbox"
      class="peer absolute h-full w-full cursor-pointer opacity-0"
      tabindex="-1"
      @input="toggle"
    />
    <span
      class="w-1/2 group-hover:w-full group-hover:bg-fuchsia-500 peer-checked:w-full peer-checked:origin-[100%_0%] peer-checked:-rotate-45"
    />
    <span
      class="w-full group-hover:bg-fuchsia-500 peer-checked:origin-center peer-checked:opacity-0"
    />
    <span
      class="w-3/4 group-hover:w-full group-hover:bg-fuchsia-500 peer-checked:w-full peer-checked:origin-[95%_100%] peer-checked:rotate-45"
    />
  </div>
</template>

<script lang="ts" setup>
const props = withDefaults(
  defineProps<{
    shown: boolean;
  }>(),
  { shown: false },
);

const value = ref(props.shown);
watch(props, ({ shown }) => (value.value = shown));

const emit = defineEmits<{
  (e: 'toggle', elem: boolean): void;
}>();

const toggle = (e: Event) => {
  e.preventDefault();
  const { checked } = e.target as HTMLInputElement;
  emit('toggle', checked);
};
</script>
